% ESERCIZIO 1
close all
clear all
clc

%A = [3  0  4; 7  4  2; -1 1  2]
%A = [-3 3  -6 ; -4  7 -8; 5 7 -9]
% A = [4  1 1; 2  -9  0; 0 -8 6]
A = [7 6  9; 4 5 -4; -7 -3 8]

D = diag(diag(A))
E = -tril(A,-1)
F = -triu(A,1)

Bj = inv(D)*(E+F);
Bgs = inv(D-E)*(F);

eA = eig(A);
eBj = eig(Bj);
eBgs = eig(Bgs);

figure(1);
h = plot(real(eA),imag(eA),'xk');
set(h,'LineWidth',3);
hold on
h = plot(real(eBj),imag(eBj),'xr');
set(h,'LineWidth',3);
h = plot(real(eBgs),imag(eBgs),'xb');
set(h,'LineWidth',3);
dis_cerc_unit;
hold off
axis equal
legend('\lambda_A','\lambda_{Bj}','\lambda_{Bgs}');
xlabel('Re(\lambda)');
ylabel('Im(\lambda)');


% Esercizio 4
A = [7 6  9; 4 5 -4; -7 -3 8]
xsol = ones(3,1)
b = A*xsol
x0 = xsol*0
tol = 1e-8
maxiter = 1000
[xj,okj,xhistj] = Jacobi(A,b,x0,tol,maxiter);
[xgs,okgs,xhistgs] = GaussSeidel(A,b,x0,tol,maxiter);

nl = min(size(xhistj,2),size(xhistgs,2));

errnormj = zeros(1,nl);
errnormgs = zeros(1,nl);
for i=1:nl
    errnormj(i) = norm(xhistj(:,i)-xsol);
    errnormgs(i) = norm(xhistgs(:,i)-xsol);
end
figure(2);
h = semilogy(errnormj);
set(h,'LineWidth',2,'Color','r');
hold on
h = semilogy(errnormgs);
set(h,'LineWidth',2,'Color','b');
hold off
legend('Jacobi','Gauss-Seidel');

