function [x,ok,xhist] = GaussSeidel(A,b,x0,tol,maxiter)

x = x0;
xhist = x;
ok = 0;
iter = 0;
scarto =  tol+1;
[m,n] = size(A);
while scarto >= tol && iter<maxiter,
    iter = iter+1;
    xnew = zeros(size(x));
    for i=1:n
        %xnew(i) = 0;
        for j=1:i-1,
            xnew(i) = xnew(i)+A(i,j)*xnew(j);
        end
        for j=i+1:n,
            xnew(i) = xnew(i)+A(i,j)*x(j);
        end
        xnew(i) = (b(i)-xnew(i))/A(i,i);
    end
    scarto = norm(xnew-x,Inf);
    x = xnew;
    xhist = [xhist,x];
end

if( scarto<tol )
    ok = 1;
end