function [x,flag,res] = mGaussSeidel(A,b,x0,tol,maxiter)

% Vettore
x = x0;
flag = false;
iter = 0;

% Matrici di Gauss-Seidel
M_gs = tril(A);
N_gs = -triu(A,+1);

normb   = norm(b);      % norma del vettore b
residuo = norm(b-A*x);  % residuo iniziale

% salvo tutti i residuo
res = residuo;

% Ciclo iterativo principale
while residuo >= tol && iter<maxiter,
    iter = iter+1;
    
    x = M_gs\(N_gs*x+b);
    residuo = norm(b-A*x);
    res(iter+1) = residuo;
end

if( residuo<tol )
    flag = true;
end
