function [x,flag,res] = mJacobi(A,b,x0,tol,maxiter)

% Vettore
x = x0;
flag = false;
iter = 0;

% Matrici di Jabobi
Minv_jac = 1./diag(A);              % vettore inversi diagonale
N_jac = -(tril(A,-1)+triu(A,+1));

normb   = norm(b);      % norma del vettore b
residuo = norm(b-A*x);  % residuo iniziale

% salvo tutti i residuo
res = residuo;

% Ciclo iterativo principale
while residuo >= tol && iter<maxiter,
    iter = iter+1;
    
    x = Minv_jac.*(N_jac*x+b);
    residuo = norm(b-A*x);
    res(iter+1) = residuo;
end

if( residuo<tol )
    flag = true;
end
